<?php

namespace NoccyLabs\React\WebSocket;

use NoccyLabs\React\WebSocket\Group\ConnectionGroup;
use Psr\Http\Message\ServerRequestInterface;
use React\Http\Message\Response;
use React\Socket\ConnectionInterface;
use React\Stream\CompositeStream;
use React\Stream\ThroughStream;

interface WebSocketInterface extends ConnectionInterface
{
    const EVENT_CONNECT = 'connect';
    const EVENT_CLOSE = 'close';
    const EVENT_GROUP_JOIN = 'join';
    const EVENT_GROUP_LEAVE = 'leave';


    public function setGroup(?string $name): void;

    public function getGroupName(): ?string;

    public function getGroup(): ?ConnectionGroup;

    public function closeWithReason(string $reason, int $code=1000);

}